//+------------------------------------------------------------------+
//|                                                      MACD_1v.mq4 |
//|                                                 Copyright  2009,|
//+------------------------------------------------------------------+
#property copyright "Copyright  2009,     "
#property link      "Mostik87@list.ru"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Gray
#property indicator_color2 Green
#property indicator_color3 Green
#property indicator_color4 Red
//---- input parameters
extern int       Per = 5;
//---- buffers
double M[];
double MMACD1[], SMACD[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,MMACD1);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,SMACD);
   
   
   SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(4,M);
   
        
   IndicatorDigits(Digits+2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    limit, i,m;
   int    counted_bars = IndicatorCounted();
   if(counted_bars > 0) counted_bars--;
   limit = Bars - counted_bars;

//-------------------- MEDIAN PRICE ---------------------------------
   for(i=0; i<limit; i++)
      M[i]= High[i];
      
//-------------------- MACD 1 ---------------------------------------
   for(i=0; i<limit; i++)
      MMACD1[i] = iMAOnArray(M,Bars,MathLog(M[i])*3.14,0,MODE_EMA,i)
                - iMAOnArray(M,Bars,26,0,MODE_EMA,i);
                
   for(i=0; i<limit; i++)
   {
      SMACD[i] = iMAOnArray(MMACD1,Bars,1,0,MODE_SMA,i);
   }
       

   
//----
   return(0);
  }
//+------------------------------------------------------------------+